/**
* @fileoverview 入口文件，对外暴露方法
* @author  liweitao
*/

'use strict';

var scan = require('./athena_scan');
var scanServer = require('./athena_scan_server');
var concat = require('./athena_concat');
var concatServer = require('./athena_concat_server');
var concatCore = require('./athena_concat_core');
var combo = require('./athena_combo');
var replace = require('./athena_replace');
var replaceServer = require('./athena_replace_server');
var rev = require('./athena_rev');
var revServer = require('./athena_rev_server');
var revNoHash = require('./athena_rev_no_hash');
var revNoHashServer = require('./athena_rev_no_hash_server');
var imagemin = require('./athena_imagemin');
var cssnano = require('./athena_cssnano');
var uglify = require('./athena_uglify');
var ssh = require('./athena_ssh');
var injectServer = require('./athena_inject_server');
var compass = require('./athena_compass');
var ftp = require('./athena_ftp');
var jdcFinder = require('./athena_jdcfinder');
var publishFilter = require('./athena_publish_filter');
var publishFilterServer = require('./athena_publish_filter_server');
var plumber = require('./athena_plumber');
var buildFilter = require('./athena_build_filter');
var sassFilter = require('./athena_sass_filter');
var sassGraph = require('./athena_sass_graph');
var babel = require('./athena_babel');
var processorJS = require('./athena_processor_js');

module.exports = {
  scan: scan,
  scanServer: scanServer,
  concat: concat,
  concatServer: concatServer,
  concatCore: concatCore,
  combo: combo,
  replace: replace,
  replaceServer: replaceServer,
  rev: rev,
  revServer: revServer,
  revNoHash: revNoHash,
  revNoHashServer: revNoHashServer,
  imagemin: imagemin,
  cssnano: cssnano,
  uglify: uglify,
  ssh: ssh,
  injectServer: injectServer,
  compass : compass,
  ftp: ftp,
  jdcFinder: jdcFinder,
  publishFilter: publishFilter,
  publishFilterServer: publishFilterServer,
  plumber: plumber,
  buildFilter: buildFilter,
  sassFilter: sassFilter,
  sassGraph: sassGraph,
  babel: babel,
  processorJS: processorJS
};
